#include "stm32f4xx.h"

#include <string.h>
#include "netconf.h"
#include "main.h"
#include "udp_echoserver.h"
#include "serial_debug.h"

#include "lwip/pbuf.h"
#include "lwip/udp.h"
#include "lwip/tcp.h"




#define SYSTEMTICK_PERIOD_MS  10

 /* this variable is used to create a time reference incremented by 10ms */
uint32_t timingdelay;

void Delay(__IO uint32_t nCount);
void mcu_init(void);
extern struct udp_pcb *upcb;

__IO uint32_t LocalTime = 0;
void Time_Update(void)
{
  LocalTime += 10;
}


int main(void) {


	struct pbuf *p;
	u8 * data = "dezo";

	GPIO_InitTypeDef strukt;
	uint32_t temp[4];
	mcu_init();

  ETH_BSP_Config();
  ETH_PHYLoopBackCmd(DP83848_PHY_ADDRESS,ENABLE);


	//Systick setup
	if (SysTick_Config(SystemCoreClock / 100))
	{
	  /* Capture error */
	  while (1);
	}

  /* Initilaize the LwIP stack */
  LwIP_Init();


  /* UDP echoserver */
  udp_echoserver_init();

  /* Infinite loop */
  while (1)
  {
	  temp[0] = ETH->MMCRFCECR;
	    temp[1] = ETH->MMCRFAECR;

	if (GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_4  ) == Bit_SET)
	{
		strukt.GPIO_Mode = 0;
	}


	 /* check if any packet received */
		 if (ETH_CheckFrameReceived())
		 {
		   /* process received ethernet packet */
		   LwIP_Pkt_Handle();
		 }
		 /* handle periodic timers for LwIP */
		 LwIP_Periodic_Handle(LocalTime);

  }
}


void mcu_init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	//GPIO Setup - ledky
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
	/* Configure PD12, 13, 14 and PD15 in output pushpull mode */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOD, &GPIO_InitStructure);




	//setup ethernet reset pin
	//reset aktivni v nule, takže na 1
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIO_SetBits(GPIOB,GPIO_Pin_10);
}

void assert_failed(uint8_t* file, uint32_t line)
{
//	while (1);
}





